Bug 1293229 - RCU stalls message on realtime kernel
Summary: RCU stalls message on realtime kernel
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: kernel-rt
Version: 7.3
Hardware: x86_64
OS: Linux
high
high
Target Milestone: rc
: ---
Assignee: Luis Claudio R. Goncalves
QA Contact:
URL:
Whiteboard:
Depends On: 1292927
Blocks: 1295885
TreeView+ depends on / blocked
 
Reported: 2015-12-21 07:06 UTC by Jan Kurik
Modified: 2019-09-12 09:37 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Cause: A possible livelock in the NAPI polling and busy polling routines could lead the system to a livelock on threads running at high, realtime, priorities. Consequence: threads running at priorities lower than the ones of the threads involved in the livelock would be prevented from running on the CPUs affected by the livelock. Among those threads are the rcuc/ threads. Fix: right before (4 jiffies) a RCU stall is detected, the rcuc/ threads on the CPUs facing the livelock have their priorities boosted above the priority of the threads involved in the livelock. Also, the softirqs are now handled in a way closer to the behavior of the upstream kernel. Result: Even under pressure thre rcuc/ threads are able to run, mitigating the RCU stalls.
Clone Of: 1292927
: 1295885 (view as bug list)
Environment:
Last Closed: 2016-02-16 10:49:54 UTC


Attachments (Terms of Use)
rcu: Boost rcuc if it has 4 jiffies before splatting (3.25 KB, patch)
2016-01-07 04:01 UTC, Luis Claudio R. Goncalves
no flags Details | Diff
softirq: Perform softirqs in local_bh_enable() for a limited amount of time (3.63 KB, patch)
2016-01-07 04:02 UTC, Luis Claudio R. Goncalves
no flags Details | Diff


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2016:0212 normal SHIPPED_LIVE Important: kernel-rt security, bug fix, and enhancement update 2016-02-16 15:46:40 UTC

Description Jan Kurik 2015-12-21 07:06:33 UTC
This bug has been copied from bug #1292927 and has been proposed
to be backported to 7.2 z-stream (EUS).

Comment 3 Luis Claudio R. Goncalves 2016-01-07 04:01:31 UTC
Created attachment 1112334 [details]
rcu: Boost rcuc if it has 4 jiffies before splatting

Comment 4 Luis Claudio R. Goncalves 2016-01-07 04:02:18 UTC
Created attachment 1112335 [details]
softirq: Perform softirqs in local_bh_enable() for a limited amount of time

Comment 9 errata-xmlrpc 2016-02-16 10:49:54 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://rhn.redhat.com/errata/RHSA-2016-0212.html


Note You need to log in before you can comment on or make changes to this bug.